"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ToggleBox = void 0;
const react_1 = __importStar(require("react"));
const prop_types_1 = __importDefault(require("prop-types"));
const components_emoji_1 = require("@react_db_client/components.emoji");
const ToggleBox = ({ stateIn, id, text, onChange, width, disabled, selectButtonProps = {}, }) => {
    const [state, setState] = (0, react_1.useState)(stateIn);
    const handleClick = () => {
        if (disabled)
            return;
        if (onChange) {
            onChange(!state, id);
        }
        else {
            setState(!state);
        }
    };
    (0, react_1.useEffect)(() => {
        setState(stateIn);
    }, [stateIn]);
    const styleOverride = text ? {} : { width };
    return (react_1.default.createElement("div", { className: "toggleBoxWrap" },
        react_1.default.createElement("button", Object.assign({ type: "button", className: state ? 'button-two' : 'button-one', onClick: handleClick, style: styleOverride }, selectButtonProps), text || (state ? react_1.default.createElement(components_emoji_1.Emoji, { emoj: "\u2714\uFE0F", label: "yes" }) : react_1.default.createElement(components_emoji_1.Emoji, { emoj: "x", label: "no" })))));
};
exports.ToggleBox = ToggleBox;
exports.ToggleBox.propTypes = {
    stateIn: prop_types_1.default.bool,
    text: prop_types_1.default.string,
    onChange: prop_types_1.default.func,
    width: prop_types_1.default.string,
    id: prop_types_1.default.oneOfType([prop_types_1.default.number, prop_types_1.default.string]).isRequired,
    disabled: prop_types_1.default.bool,
};
exports.ToggleBox.defaultProps = {
    text: null,
    stateIn: false,
    width: '100%',
    disabled: false,
    onChange: () => {
        throw Error('onChange not set!');
    },
};
//# sourceMappingURL=toggle-box.js.map